from MadGraphControl.MadGraphUtils import *
from MadGraphControl.MadGraphUtilsHelpers import *
import math
import os
import MadGraphControl.MadGraph_NNPDF30NLO_Base_Fragment

keepOutput=False
gridpack_mode = True
generate_gridpack = False
evgenConfig.inputconfcheck=""

if hasattr(runArgs, 'ecmEnergy'):
   beamEnergy = runArgs.ecmEnergy / 2.
else:
   raise RuntimeError("No center-of-mass energy provided in the Gen_tf.py command, exiting now.")

# H3 = iota0, H2 = eta0 heavy scalars, H=hSM
# M3>M2>M1
# Benchmark scenario 3 in https://link.springer.com/article/10.1140%2Fepjc%2Fs10052-020-7655-x
# Parameters chosen to maximise iota0 production and Br(iota0->H+eta0)
# Sample job options should have name such as mc.MGPy8EG_A14N23LO_TRSM_HHH_bbbbbb_500p0_200p0.py
JO = get_physics_short()
sample_name_list = JO.split('_')

def sample_name_to_parameters(sample_name_list):
  topology = sample_name_list[-4]
  decay = sample_name_list[-3]
  M3_str = sample_name_list[-2]
  M2_str = sample_name_list[-1].replace(".GRID.tar.gz","")
  return M3_str,M2_str,topology,decay

M3_str,M2_str,topology,decay = sample_name_to_parameters(sample_name_list)
v = 246.
vs = 140.
vx = 100.
M1 = 125.09
M2 = float(M2_str.replace('p','.'))
M3 = float(M3_str.replace('p','.'))
a12=-0.129
a13= 0.226
a23=-0.899

# Scale up the LHE events to make it more likely pythia will be happy
SafeFactorDict = { "325p0,200p0":4.0, "400p0,200p0":3.6, "475p0,200p0":3.6, "550p0,200p0":3.6, "350p0,225p0":4.1, "425p0,225p0":4.0, "500p0,225p0":3.6, "575p0,225p0":3.6, "375p0,250p0":4.0, "425p0,250p0":4.1, "475p0,250p0":4.3, "525p0,250p0":4.1, "550p0,250p0":3.9, "400p0,275p0":4.5, "450p0,275p0":4.5, "500p0,275p0":4.0, "550p0,275p0":3.9, "425p0,300p0":4.5, "450p0,300p0":4.2, "500p0,300p0":4.3, "540p0,300p0":4.1, "450p0,325p0":4.3, "485p0,325p0":4.2, "520p0,325p0":4.2, "475p0,350p0":4.2, "500p0,350p0":4.2, "400p0,260p0":4.5, "450p0,260p0":4.5, "500p0,260p0":4.0, "550p0,260p0":3.9, "425p0,285p0":4.4, "525p0,285p0":4.1, "450p0,310p0":4.4, "520p0,310p0":4.0, "485p0,340p0":4.2}
if not generate_gridpack:
   SafeFactor = 4.0
   if M3_str+","+M2_str in SafeFactorDict: SafeFactor = SafeFactorDict[M3_str+","+M2_str]
   nevents = runArgs.maxEvents*SafeFactor
else: 
   nevents = runArgs.maxEvents

# model masses for param card
masses = {'99925':M2,'99926':M3}

# the R mixing matrix given the cosines of the angles
def Rmatrix(a12, a13, a23):
    # define output matrix
    R = [[0. for x in range(3)] for y in range(3)]
    #calculate the cos functions
    c1 = math.cos(a12)
    c2 = math.cos(a13)
    c3 = math.cos(a23)
    # get the sin functions
    s1 = math.sin(a12)
    s2 = math.sin(a13)
    s3 = math.sin(a23)

    # calculate the elements
    R[0][0] = c1 * c2
    R[0][1] = - s1 * c2
    R[0][2] = - s2
    R[1][0] = s1 * c3 - c1 * s2 * s3
    R[1][1] = c1 * c3 + s1 * s2 * s3
    R[1][2] = - c2 * s3
    R[2][0] = c1 * s2 * c3 + s1 * s3
    R[2][1] = c1 * s3 - s1 * s2 * c3
    R[2][2] = c2 * c3
    return R

#calculate the cos functions
c1 = math.cos(a12)
c2 = math.cos(a13)
c3 = math.cos(a23)
# first get the R-matrix 
R = Rmatrix(a12, a13, a23)
R11, R12, R13, R21, R22, R23, R31, R32, R33 = R[0][0], R[0][1], R[0][2], R[1][0], R[1][1], R[1][2], R[2][0], R[2][1], R[2][2]

# Work out triple couplings
kap111 = (M1**2*(R11**3/v + R12**3/vs + R13**3/vx))/2.
kap112 = ((2*M1**2 + M2**2)*((R11**2*R21)/v + (R12**2*R22)/vs + (R13**2*R23)/vx))/2.
kap113 = ((2*M1**2 + M3**2)*((R11**2*R31)/v + (R12**2*R32)/vs + (R13**2*R33)/vx))/2.
kap122 = ((M1**2 + 2*M2**2)*((R11*R21**2)/v + (R12*R22**2)/vs + (R13*R23**2)/vx))/2.
kap123 = (M1**2 + M2**2 + M3**2)*((R11*R21*R31)/v + (R12*R22*R32)/vs + (R13*R23*R33)/vx)
kap133 = ((M1**2 + 2*M3**2)*((R11*R31**2)/v + (R12*R32**2)/vs + (R13*R33**2)/vx))/2.
kap222 = (M2**2*(R21**3/v + R22**3/vs + R23**3/vx))/2.
kap223 = ((2*M2**2 + M3**2)*((R21**2*R31)/v + (R22**2*R32)/vs + (R23**2*R33)/vx))/2.
kap233 = ((M2**2 + 2*M3**2)*((R21*R31**2)/v + (R22*R32**2)/vs + (R23*R33**2)/vx))/2.
kap333 = (M3**2*(R31**3/v + R32**3/vs + R33**3/vx))/2.
# Work out quartic couplings
kap1111 = (0.125*M1**2*R11**6)/v**2 + (0.125*M2**2*R11**4*R21**2)/v**2 + (0.125*M3**2*R11**4*R31**2)/v**2 + (0.125*M1**2*R12**6)/vs**2 + (0.125*M2**2*R12**4*R22**2)/vs**2 + (0.125*M3**2*R12**4*R32**2)/vs**2 + (0.25*M1**2*R11**3*R12**3)/(v*vs) + (0.25*M2**2*R11**2*R12**2*R21*R22)/(v*vs) + (0.25*M3**2*R11**2*R12**2*R31*R32)/(v*vs) + (0.125*M1**2*R13**6)/vx**2 + (0.125*M2**2*R13**4*R23**2)/vx**2 + (0.125*M3**2*R13**4*R33**2)/vx**2 + (0.25*M1**2*R11**3*R13**3)/(v*vx) + (0.25*M2**2*R11**2*R13**2*R21*R23)/(v*vx) + (0.25*M3**2*R11**2*R13**2*R31*R33)/(v*vx) + (0.25*M1**2*R12**3*R13**3)/(vs*vx) + (0.25*M2**2*R12**2*R13**2*R22*R23)/(vs*vx) + (0.25*M3**2*R12**2*R13**2*R32*R33)/(vs*vx)
kap1112 = (0.5*M1**2*R11**5*R21)/v**2 + (0.5*M2**2*R11**3*R21**3)/v**2 + (0.5*M3**2*R11**3*R21*R31**2)/v**2 + (0.5*M1**2*R12**5*R22)/vs**2 + (0.5*M2**2*R12**3*R22**3)/vs**2 + (0.5*M3**2*R12**3*R22*R32**2)/vs**2 + (0.5*M1**2*R11**2*R12**3*R21)/(v*vs) + (0.5*M1**2*R11**3*R12**2*R22)/(v*vs) + (0.5*M2**2*R11*R12**2*R21**2*R22)/(v*vs) + (0.5*M2**2*R11**2*R12*R21*R22**2)/(v*vs) + (0.5*M3**2*R11*R12**2*R21*R31*R32)/(v*vs) + (0.5*M3**2*R11**2*R12*R22*R31*R32)/(v*vs) + (0.5*M1**2*R13**5*R23)/vx**2 + (0.5*M2**2*R13**3*R23**3)/vx**2 + (0.5*M3**2*R13**3*R23*R33**2)/vx**2 + (0.5*M1**2*R11**2*R13**3*R21)/(v*vx) + (0.5*M1**2*R11**3*R13**2*R23)/(v*vx) + (0.5*M2**2*R11*R13**2*R21**2*R23)/(v*vx) + (0.5*M2**2*R11**2*R13*R21*R23**2)/(v*vx) + (0.5*M3**2*R11*R13**2*R21*R31*R33)/(v*vx) + (0.5*M3**2*R11**2*R13*R23*R31*R33)/(v*vx) + (0.5*M1**2*R12**2*R13**3*R22)/(vs*vx) + (0.5*M1**2*R12**3*R13**2*R23)/(vs*vx) + (0.5*M2**2*R12*R13**2*R22**2*R23)/(vs*vx) + (0.5*M2**2*R12**2*R13*R22*R23**2)/(vs*vx) + (0.5*M3**2*R12*R13**2*R22*R32*R33)/(vs*vx) + (0.5*M3**2*R12**2*R13*R23*R32*R33)/(vs*vx)
kap1113 = (0.5*M1**2*R11**5*R31)/v**2 + (0.5*M2**2*R11**3*R21**2*R31)/v**2 + (0.5*M3**2*R11**3*R31**3)/v**2 + (0.5*M1**2*R12**5*R32)/vs**2 + (0.5*M2**2*R12**3*R22**2*R32)/vs**2 + (0.5*M3**2*R12**3*R32**3)/vs**2 + (0.5*M1**2*R11**2*R12**3*R31)/(v*vs) + (0.5*M2**2*R11*R12**2*R21*R22*R31)/(v*vs) + (0.5*M1**2*R11**3*R12**2*R32)/(v*vs) + (0.5*M2**2*R11**2*R12*R21*R22*R32)/(v*vs) + (0.5*M3**2*R11*R12**2*R31**2*R32)/(v*vs) + (0.5*M3**2*R11**2*R12*R31*R32**2)/(v*vs) + (0.5*M1**2*R13**5*R33)/vx**2 + (0.5*M2**2*R13**3*R23**2*R33)/vx**2 + (0.5*M3**2*R13**3*R33**3)/vx**2 + (0.5*M1**2*R11**2*R13**3*R31)/(v*vx) + (0.5*M2**2*R11*R13**2*R21*R23*R31)/(v*vx) + (0.5*M1**2*R11**3*R13**2*R33)/(v*vx) + (0.5*M2**2*R11**2*R13*R21*R23*R33)/(v*vx) + (0.5*M3**2*R11*R13**2*R31**2*R33)/(v*vx) + (0.5*M3**2*R11**2*R13*R31*R33**2)/(v*vx) + (0.5*M1**2*R12**2*R13**3*R32)/(vs*vx) + (0.5*M2**2*R12*R13**2*R22*R23*R32)/(vs*vx) + (0.5*M1**2*R12**3*R13**2*R33)/(vs*vx) + (0.5*M2**2*R12**2*R13*R22*R23*R33)/(vs*vx) + (0.5*M3**2*R12*R13**2*R32**2*R33)/(vs*vx) + (0.5*M3**2*R12**2*R13*R32*R33**2)/(vs*vx)
kap1122 = (0.75*M1**2*R11**4*R21**2)/v**2 + (0.75*M2**2*R11**2*R21**4)/v**2 + (0.75*M3**2*R11**2*R21**2*R31**2)/v**2 + (0.75*M1**2*R12**4*R22**2)/vs**2 + (0.75*M2**2*R12**2*R22**4)/vs**2 + (0.75*M3**2*R12**2*R22**2*R32**2)/vs**2 + (0.25*M1**2*R11*R12**3*R21**2)/(v*vs) + (1.*M1**2*R11**2*R12**2*R21*R22)/(v*vs) + (0.25*M2**2*R12**2*R21**3*R22)/(v*vs) + (0.25*M1**2*R11**3*R12*R22**2)/(v*vs) + (1.*M2**2*R11*R12*R21**2*R22**2)/(v*vs) + (0.25*M2**2*R11**2*R21*R22**3)/(v*vs) + (0.25*M3**2*R12**2*R21**2*R31*R32)/(v*vs) + (1.*M3**2*R11*R12*R21*R22*R31*R32)/(v*vs) + (0.25*M3**2*R11**2*R22**2*R31*R32)/(v*vs) + (0.75*M1**2*R13**4*R23**2)/vx**2 + (0.75*M2**2*R13**2*R23**4)/vx**2 + (0.75*M3**2*R13**2*R23**2*R33**2)/vx**2 + (0.25*M1**2*R11*R13**3*R21**2)/(v*vx) + (1.*M1**2*R11**2*R13**2*R21*R23)/(v*vx) + (0.25*M2**2*R13**2*R21**3*R23)/(v*vx) + (0.25*M1**2*R11**3*R13*R23**2)/(v*vx) + (1.*M2**2*R11*R13*R21**2*R23**2)/(v*vx) + (0.25*M2**2*R11**2*R21*R23**3)/(v*vx) + (0.25*M3**2*R13**2*R21**2*R31*R33)/(v*vx) + (1.*M3**2*R11*R13*R21*R23*R31*R33)/(v*vx) + (0.25*M3**2*R11**2*R23**2*R31*R33)/(v*vx) + (0.25*M1**2*R12*R13**3*R22**2)/(vs*vx) + (1.*M1**2*R12**2*R13**2*R22*R23)/(vs*vx) + (0.25*M2**2*R13**2*R22**3*R23)/(vs*vx) + (0.25*M1**2*R12**3*R13*R23**2)/(vs*vx) + (1.*M2**2*R12*R13*R22**2*R23**2)/(vs*vx) + (0.25*M2**2*R12**2*R22*R23**3)/(vs*vx) + (0.25*M3**2*R13**2*R22**2*R32*R33)/(vs*vx) + (1.*M3**2*R12*R13*R22*R23*R32*R33)/(vs*vx) + (0.25*M3**2*R12**2*R23**2*R32*R33)/(vs*vx)
kap1123 = (1.5*M1**2*R11**4*R21*R31)/v**2 + (1.5*M2**2*R11**2*R21**3*R31)/v**2 + (1.5*M3**2*R11**2*R21*R31**3)/v**2 + (1.5*M1**2*R12**4*R22*R32)/vs**2 + (1.5*M2**2*R12**2*R22**3*R32)/vs**2 + (1.5*M3**2*R12**2*R22*R32**3)/vs**2 + (0.5*M1**2*R11*R12**3*R21*R31)/(v*vs) + (1.*M1**2*R11**2*R12**2*R22*R31)/(v*vs) + (0.5*M2**2*R12**2*R21**2*R22*R31)/(v*vs) + (1.*M2**2*R11*R12*R21*R22**2*R31)/(v*vs) + (1.*M1**2*R11**2*R12**2*R21*R32)/(v*vs) + (0.5*M1**2*R11**3*R12*R22*R32)/(v*vs) + (1.*M2**2*R11*R12*R21**2*R22*R32)/(v*vs) + (0.5*M2**2*R11**2*R21*R22**2*R32)/(v*vs) + (0.5*M3**2*R12**2*R21*R31**2*R32)/(v*vs) + (1.*M3**2*R11*R12*R22*R31**2*R32)/(v*vs) + (1.*M3**2*R11*R12*R21*R31*R32**2)/(v*vs) + (0.5*M3**2*R11**2*R22*R31*R32**2)/(v*vs) + (1.5*M1**2*R13**4*R23*R33)/vx**2 + (1.5*M2**2*R13**2*R23**3*R33)/vx**2 + (1.5*M3**2*R13**2*R23*R33**3)/vx**2 + (0.5*M1**2*R11*R13**3*R21*R31)/(v*vx) + (1.*M1**2*R11**2*R13**2*R23*R31)/(v*vx) + (0.5*M2**2*R13**2*R21**2*R23*R31)/(v*vx) + (1.*M2**2*R11*R13*R21*R23**2*R31)/(v*vx) + (1.*M1**2*R11**2*R13**2*R21*R33)/(v*vx) + (0.5*M1**2*R11**3*R13*R23*R33)/(v*vx) + (1.*M2**2*R11*R13*R21**2*R23*R33)/(v*vx) + (0.5*M2**2*R11**2*R21*R23**2*R33)/(v*vx) + (0.5*M3**2*R13**2*R21*R31**2*R33)/(v*vx) + (1.*M3**2*R11*R13*R23*R31**2*R33)/(v*vx) + (1.*M3**2*R11*R13*R21*R31*R33**2)/(v*vx) + (0.5*M3**2*R11**2*R23*R31*R33**2)/(v*vx) + (0.5*M1**2*R12*R13**3*R22*R32)/(vs*vx) + (1.*M1**2*R12**2*R13**2*R23*R32)/(vs*vx) + (0.5*M2**2*R13**2*R22**2*R23*R32)/(vs*vx) + (1.*M2**2*R12*R13*R22*R23**2*R32)/(vs*vx) + (1.*M1**2*R12**2*R13**2*R22*R33)/(vs*vx) + (0.5*M1**2*R12**3*R13*R23*R33)/(vs*vx) + (1.*M2**2*R12*R13*R22**2*R23*R33)/(vs*vx) + (0.5*M2**2*R12**2*R22*R23**2*R33)/(vs*vx) + (0.5*M3**2*R13**2*R22*R32**2*R33)/(vs*vx) + (1.*M3**2*R12*R13*R23*R32**2*R33)/(vs*vx) + (1.*M3**2*R12*R13*R22*R32*R33**2)/(vs*vx) + (0.5*M3**2*R12**2*R23*R32*R33**2)/(vs*vx)
kap1133 = (0.75*M1**2*R11**4*R31**2)/v**2 + (0.75*M2**2*R11**2*R21**2*R31**2)/v**2 + (0.75*M3**2*R11**2*R31**4)/v**2 + (0.75*M1**2*R12**4*R32**2)/vs**2 + (0.75*M2**2*R12**2*R22**2*R32**2)/vs**2 + (0.75*M3**2*R12**2*R32**4)/vs**2 + (0.25*M1**2*R11*R12**3*R31**2)/(v*vs) + (0.25*M2**2*R12**2*R21*R22*R31**2)/(v*vs) + (1.*M1**2*R11**2*R12**2*R31*R32)/(v*vs) + (1.*M2**2*R11*R12*R21*R22*R31*R32)/(v*vs) + (0.25*M3**2*R12**2*R31**3*R32)/(v*vs) + (0.25*M1**2*R11**3*R12*R32**2)/(v*vs) + (0.25*M2**2*R11**2*R21*R22*R32**2)/(v*vs) + (1.*M3**2*R11*R12*R31**2*R32**2)/(v*vs) + (0.25*M3**2*R11**2*R31*R32**3)/(v*vs) + (0.75*M1**2*R13**4*R33**2)/vx**2 + (0.75*M2**2*R13**2*R23**2*R33**2)/vx**2 + (0.75*M3**2*R13**2*R33**4)/vx**2 + (0.25*M1**2*R11*R13**3*R31**2)/(v*vx) + (0.25*M2**2*R13**2*R21*R23*R31**2)/(v*vx) + (1.*M1**2*R11**2*R13**2*R31*R33)/(v*vx) + (1.*M2**2*R11*R13*R21*R23*R31*R33)/(v*vx) + (0.25*M3**2*R13**2*R31**3*R33)/(v*vx) + (0.25*M1**2*R11**3*R13*R33**2)/(v*vx) + (0.25*M2**2*R11**2*R21*R23*R33**2)/(v*vx) + (1.*M3**2*R11*R13*R31**2*R33**2)/(v*vx) + (0.25*M3**2*R11**2*R31*R33**3)/(v*vx) + (0.25*M1**2*R12*R13**3*R32**2)/(vs*vx) + (0.25*M2**2*R13**2*R22*R23*R32**2)/(vs*vx) + (1.*M1**2*R12**2*R13**2*R32*R33)/(vs*vx) + (1.*M2**2*R12*R13*R22*R23*R32*R33)/(vs*vx) + (0.25*M3**2*R13**2*R32**3*R33)/(vs*vx) + (0.25*M1**2*R12**3*R13*R33**2)/(vs*vx) + (0.25*M2**2*R12**2*R22*R23*R33**2)/(vs*vx) + (1.*M3**2*R12*R13*R32**2*R33**2)/(vs*vx) + (0.25*M3**2*R12**2*R32*R33**3)/(vs*vx)
kap1222 = (0.5*M1**2*R11**3*R21**3)/v**2 + (0.5*M2**2*R11*R21**5)/v**2 + (0.5*M3**2*R11*R21**3*R31**2)/v**2 + (0.5*M1**2*R12**3*R22**3)/vs**2 + (0.5*M2**2*R12*R22**5)/vs**2 + (0.5*M3**2*R12*R22**3*R32**2)/vs**2 + (0.5*M1**2*R11*R12**2*R21**2*R22)/(v*vs) + (0.5*M1**2*R11**2*R12*R21*R22**2)/(v*vs) + (0.5*M2**2*R12*R21**3*R22**2)/(v*vs) + (0.5*M2**2*R11*R21**2*R22**3)/(v*vs) + (0.5*M3**2*R12*R21**2*R22*R31*R32)/(v*vs) + (0.5*M3**2*R11*R21*R22**2*R31*R32)/(v*vs) + (0.5*M1**2*R13**3*R23**3)/vx**2 + (0.5*M2**2*R13*R23**5)/vx**2 + (0.5*M3**2*R13*R23**3*R33**2)/vx**2 + (0.5*M1**2*R11*R13**2*R21**2*R23)/(v*vx) + (0.5*M1**2*R11**2*R13*R21*R23**2)/(v*vx) + (0.5*M2**2*R13*R21**3*R23**2)/(v*vx) + (0.5*M2**2*R11*R21**2*R23**3)/(v*vx) + (0.5*M3**2*R13*R21**2*R23*R31*R33)/(v*vx) + (0.5*M3**2*R11*R21*R23**2*R31*R33)/(v*vx) + (0.5*M1**2*R12*R13**2*R22**2*R23)/(vs*vx) + (0.5*M1**2*R12**2*R13*R22*R23**2)/(vs*vx) + (0.5*M2**2*R13*R22**3*R23**2)/(vs*vx) + (0.5*M2**2*R12*R22**2*R23**3)/(vs*vx) + (0.5*M3**2*R13*R22**2*R23*R32*R33)/(vs*vx) + (0.5*M3**2*R12*R22*R23**2*R32*R33)/(vs*vx)
kap1223 = (1.5*M1**2*R11**3*R21**2*R31)/v**2 + (1.5*M2**2*R11*R21**4*R31)/v**2 + (1.5*M3**2*R11*R21**2*R31**3)/v**2 + (1.5*M1**2*R12**3*R22**2*R32)/vs**2 + (1.5*M2**2*R12*R22**4*R32)/vs**2 + (1.5*M3**2*R12*R22**2*R32**3)/vs**2 + (1.*M1**2*R11*R12**2*R21*R22*R31)/(v*vs) + (0.5*M1**2*R11**2*R12*R22**2*R31)/(v*vs) + (1.*M2**2*R12*R21**2*R22**2*R31)/(v*vs) + (0.5*M2**2*R11*R21*R22**3*R31)/(v*vs) + (0.5*M1**2*R11*R12**2*R21**2*R32)/(v*vs) + (1.*M1**2*R11**2*R12*R21*R22*R32)/(v*vs) + (0.5*M2**2*R12*R21**3*R22*R32)/(v*vs) + (1.*M2**2*R11*R21**2*R22**2*R32)/(v*vs) + (1.*M3**2*R12*R21*R22*R31**2*R32)/(v*vs) + (0.5*M3**2*R11*R22**2*R31**2*R32)/(v*vs) + (0.5*M3**2*R12*R21**2*R31*R32**2)/(v*vs) + (1.*M3**2*R11*R21*R22*R31*R32**2)/(v*vs) + (1.5*M1**2*R13**3*R23**2*R33)/vx**2 + (1.5*M2**2*R13*R23**4*R33)/vx**2 + (1.5*M3**2*R13*R23**2*R33**3)/vx**2 + (1.*M1**2*R11*R13**2*R21*R23*R31)/(v*vx) + (0.5*M1**2*R11**2*R13*R23**2*R31)/(v*vx) + (1.*M2**2*R13*R21**2*R23**2*R31)/(v*vx) + (0.5*M2**2*R11*R21*R23**3*R31)/(v*vx) + (0.5*M1**2*R11*R13**2*R21**2*R33)/(v*vx) + (1.*M1**2*R11**2*R13*R21*R23*R33)/(v*vx) + (0.5*M2**2*R13*R21**3*R23*R33)/(v*vx) + (1.*M2**2*R11*R21**2*R23**2*R33)/(v*vx) + (1.*M3**2*R13*R21*R23*R31**2*R33)/(v*vx) + (0.5*M3**2*R11*R23**2*R31**2*R33)/(v*vx) + (0.5*M3**2*R13*R21**2*R31*R33**2)/(v*vx) + (1.*M3**2*R11*R21*R23*R31*R33**2)/(v*vx) + (1.*M1**2*R12*R13**2*R22*R23*R32)/(vs*vx) + (0.5*M1**2*R12**2*R13*R23**2*R32)/(vs*vx) + (1.*M2**2*R13*R22**2*R23**2*R32)/(vs*vx) + (0.5*M2**2*R12*R22*R23**3*R32)/(vs*vx) + (0.5*M1**2*R12*R13**2*R22**2*R33)/(vs*vx) + (1.*M1**2*R12**2*R13*R22*R23*R33)/(vs*vx) + (0.5*M2**2*R13*R22**3*R23*R33)/(vs*vx) + (1.*M2**2*R12*R22**2*R23**2*R33)/(vs*vx) + (1.*M3**2*R13*R22*R23*R32**2*R33)/(vs*vx) + (0.5*M3**2*R12*R23**2*R32**2*R33)/(vs*vx) + (0.5*M3**2*R13*R22**2*R32*R33**2)/(vs*vx) + (1.*M3**2*R12*R22*R23*R32*R33**2)/(vs*vx)
kap1233 = (1.5*M1**2*R11**3*R21*R31**2)/v**2 + (1.5*M2**2*R11*R21**3*R31**2)/v**2 + (1.5*M3**2*R11*R21*R31**4)/v**2 + (1.5*M1**2*R12**3*R22*R32**2)/vs**2 + (1.5*M2**2*R12*R22**3*R32**2)/vs**2 + (1.5*M3**2*R12*R22*R32**4)/vs**2 + (0.5*M1**2*R11*R12**2*R22*R31**2)/(v*vs) + (0.5*M2**2*R12*R21*R22**2*R31**2)/(v*vs) + (1.*M1**2*R11*R12**2*R21*R31*R32)/(v*vs) + (1.*M1**2*R11**2*R12*R22*R31*R32)/(v*vs) + (1.*M2**2*R12*R21**2*R22*R31*R32)/(v*vs) + (1.*M2**2*R11*R21*R22**2*R31*R32)/(v*vs) + (0.5*M3**2*R12*R22*R31**3*R32)/(v*vs) + (0.5*M1**2*R11**2*R12*R21*R32**2)/(v*vs) + (0.5*M2**2*R11*R21**2*R22*R32**2)/(v*vs) + (1.*M3**2*R12*R21*R31**2*R32**2)/(v*vs) + (1.*M3**2*R11*R22*R31**2*R32**2)/(v*vs) + (0.5*M3**2*R11*R21*R31*R32**3)/(v*vs) + (1.5*M1**2*R13**3*R23*R33**2)/vx**2 + (1.5*M2**2*R13*R23**3*R33**2)/vx**2 + (1.5*M3**2*R13*R23*R33**4)/vx**2 + (0.5*M1**2*R11*R13**2*R23*R31**2)/(v*vx) + (0.5*M2**2*R13*R21*R23**2*R31**2)/(v*vx) + (1.*M1**2*R11*R13**2*R21*R31*R33)/(v*vx) + (1.*M1**2*R11**2*R13*R23*R31*R33)/(v*vx) + (1.*M2**2*R13*R21**2*R23*R31*R33)/(v*vx) + (1.*M2**2*R11*R21*R23**2*R31*R33)/(v*vx) + (0.5*M3**2*R13*R23*R31**3*R33)/(v*vx) + (0.5*M1**2*R11**2*R13*R21*R33**2)/(v*vx) + (0.5*M2**2*R11*R21**2*R23*R33**2)/(v*vx) + (1.*M3**2*R13*R21*R31**2*R33**2)/(v*vx) + (1.*M3**2*R11*R23*R31**2*R33**2)/(v*vx) + (0.5*M3**2*R11*R21*R31*R33**3)/(v*vx) + (0.5*M1**2*R12*R13**2*R23*R32**2)/(vs*vx) + (0.5*M2**2*R13*R22*R23**2*R32**2)/(vs*vx) + (1.*M1**2*R12*R13**2*R22*R32*R33)/(vs*vx) + (1.*M1**2*R12**2*R13*R23*R32*R33)/(vs*vx) + (1.*M2**2*R13*R22**2*R23*R32*R33)/(vs*vx) + (1.*M2**2*R12*R22*R23**2*R32*R33)/(vs*vx) + (0.5*M3**2*R13*R23*R32**3*R33)/(vs*vx) + (0.5*M1**2*R12**2*R13*R22*R33**2)/(vs*vx) + (0.5*M2**2*R12*R22**2*R23*R33**2)/(vs*vx) + (1.*M3**2*R13*R22*R32**2*R33**2)/(vs*vx) + (1.*M3**2*R12*R23*R32**2*R33**2)/(vs*vx) + (0.5*M3**2*R12*R22*R32*R33**3)/(vs*vx)
kap1333 = (0.5*M1**2*R11**3*R31**3)/v**2 + (0.5*M2**2*R11*R21**2*R31**3)/v**2 + (0.5*M3**2*R11*R31**5)/v**2 + (0.5*M1**2*R12**3*R32**3)/vs**2 + (0.5*M2**2*R12*R22**2*R32**3)/vs**2 + (0.5*M3**2*R12*R32**5)/vs**2 + (0.5*M1**2*R11*R12**2*R31**2*R32)/(v*vs) + (0.5*M2**2*R12*R21*R22*R31**2*R32)/(v*vs) + (0.5*M1**2*R11**2*R12*R31*R32**2)/(v*vs) + (0.5*M2**2*R11*R21*R22*R31*R32**2)/(v*vs) + (0.5*M3**2*R12*R31**3*R32**2)/(v*vs) + (0.5*M3**2*R11*R31**2*R32**3)/(v*vs) + (0.5*M1**2*R13**3*R33**3)/vx**2 + (0.5*M2**2*R13*R23**2*R33**3)/vx**2 + (0.5*M3**2*R13*R33**5)/vx**2 + (0.5*M1**2*R11*R13**2*R31**2*R33)/(v*vx) + (0.5*M2**2*R13*R21*R23*R31**2*R33)/(v*vx) + (0.5*M1**2*R11**2*R13*R31*R33**2)/(v*vx) + (0.5*M2**2*R11*R21*R23*R31*R33**2)/(v*vx) + (0.5*M3**2*R13*R31**3*R33**2)/(v*vx) + (0.5*M3**2*R11*R31**2*R33**3)/(v*vx) + (0.5*M1**2*R12*R13**2*R32**2*R33)/(vs*vx) + (0.5*M2**2*R13*R22*R23*R32**2*R33)/(vs*vx) + (0.5*M1**2*R12**2*R13*R32*R33**2)/(vs*vx) + (0.5*M2**2*R12*R22*R23*R32*R33**2)/(vs*vx) + (0.5*M3**2*R13*R32**3*R33**2)/(vs*vx) + (0.5*M3**2*R12*R32**2*R33**3)/(vs*vx)
kap2222 = (0.125*M1**2*R11**2*R21**4)/v**2 + (0.125*M2**2*R21**6)/v**2 + (0.125*M3**2*R21**4*R31**2)/v**2 + (0.125*M1**2*R12**2*R22**4)/vs**2 + (0.125*M2**2*R22**6)/vs**2 + (0.125*M3**2*R22**4*R32**2)/vs**2 + (0.25*M1**2*R11*R12*R21**2*R22**2)/(v*vs) + (0.25*M2**2*R21**3*R22**3)/(v*vs) + (0.25*M3**2*R21**2*R22**2*R31*R32)/(v*vs) + (0.125*M1**2*R13**2*R23**4)/vx**2 + (0.125*M2**2*R23**6)/vx**2 + (0.125*M3**2*R23**4*R33**2)/vx**2 + (0.25*M1**2*R11*R13*R21**2*R23**2)/(v*vx) + (0.25*M2**2*R21**3*R23**3)/(v*vx) + (0.25*M3**2*R21**2*R23**2*R31*R33)/(v*vx) + (0.25*M1**2*R12*R13*R22**2*R23**2)/(vs*vx) + (0.25*M2**2*R22**3*R23**3)/(vs*vx) + (0.25*M3**2*R22**2*R23**2*R32*R33)/(vs*vx)
kap2223 = (0.5*M1**2*R11**2*R21**3*R31)/v**2 + (0.5*M2**2*R21**5*R31)/v**2 + (0.5*M3**2*R21**3*R31**3)/v**2 + (0.5*M1**2*R12**2*R22**3*R32)/vs**2 + (0.5*M2**2*R22**5*R32)/vs**2 + (0.5*M3**2*R22**3*R32**3)/vs**2 + (0.5*M1**2*R11*R12*R21*R22**2*R31)/(v*vs) + (0.5*M2**2*R21**2*R22**3*R31)/(v*vs) + (0.5*M1**2*R11*R12*R21**2*R22*R32)/(v*vs) + (0.5*M2**2*R21**3*R22**2*R32)/(v*vs) + (0.5*M3**2*R21*R22**2*R31**2*R32)/(v*vs) + (0.5*M3**2*R21**2*R22*R31*R32**2)/(v*vs) + (0.5*M1**2*R13**2*R23**3*R33)/vx**2 + (0.5*M2**2*R23**5*R33)/vx**2 + (0.5*M3**2*R23**3*R33**3)/vx**2 + (0.5*M1**2*R11*R13*R21*R23**2*R31)/(v*vx) + (0.5*M2**2*R21**2*R23**3*R31)/(v*vx) + (0.5*M1**2*R11*R13*R21**2*R23*R33)/(v*vx) + (0.5*M2**2*R21**3*R23**2*R33)/(v*vx) + (0.5*M3**2*R21*R23**2*R31**2*R33)/(v*vx) + (0.5*M3**2*R21**2*R23*R31*R33**2)/(v*vx) + (0.5*M1**2*R12*R13*R22*R23**2*R32)/(vs*vx) + (0.5*M2**2*R22**2*R23**3*R32)/(vs*vx) + (0.5*M1**2*R12*R13*R22**2*R23*R33)/(vs*vx) + (0.5*M2**2*R22**3*R23**2*R33)/(vs*vx) + (0.5*M3**2*R22*R23**2*R32**2*R33)/(vs*vx) + (0.5*M3**2*R22**2*R23*R32*R33**2)/(vs*vx)
kap2233 = (0.75*M1**2*R11**2*R21**2*R31**2)/v**2 + (0.75*M2**2*R21**4*R31**2)/v**2 + (0.75*M3**2*R21**2*R31**4)/v**2 + (0.75*M1**2*R12**2*R22**2*R32**2)/vs**2 + (0.75*M2**2*R22**4*R32**2)/vs**2 + (0.75*M3**2*R22**2*R32**4)/vs**2 + (0.25*M1**2*R11*R12*R22**2*R31**2)/(v*vs) + (0.25*M2**2*R21*R22**3*R31**2)/(v*vs) + (1.*M1**2*R11*R12*R21*R22*R31*R32)/(v*vs) + (1.*M2**2*R21**2*R22**2*R31*R32)/(v*vs) + (0.25*M3**2*R22**2*R31**3*R32)/(v*vs) + (0.25*M1**2*R11*R12*R21**2*R32**2)/(v*vs) + (0.25*M2**2*R21**3*R22*R32**2)/(v*vs) + (1.*M3**2*R21*R22*R31**2*R32**2)/(v*vs) + (0.25*M3**2*R21**2*R31*R32**3)/(v*vs) + (0.75*M1**2*R13**2*R23**2*R33**2)/vx**2 + (0.75*M2**2*R23**4*R33**2)/vx**2 + (0.75*M3**2*R23**2*R33**4)/vx**2 + (0.25*M1**2*R11*R13*R23**2*R31**2)/(v*vx) + (0.25*M2**2*R21*R23**3*R31**2)/(v*vx) + (1.*M1**2*R11*R13*R21*R23*R31*R33)/(v*vx) + (1.*M2**2*R21**2*R23**2*R31*R33)/(v*vx) + (0.25*M3**2*R23**2*R31**3*R33)/(v*vx) + (0.25*M1**2*R11*R13*R21**2*R33**2)/(v*vx) + (0.25*M2**2*R21**3*R23*R33**2)/(v*vx) + (1.*M3**2*R21*R23*R31**2*R33**2)/(v*vx) + (0.25*M3**2*R21**2*R31*R33**3)/(v*vx) + (0.25*M1**2*R12*R13*R23**2*R32**2)/(vs*vx) + (0.25*M2**2*R22*R23**3*R32**2)/(vs*vx) + (1.*M1**2*R12*R13*R22*R23*R32*R33)/(vs*vx) + (1.*M2**2*R22**2*R23**2*R32*R33)/(vs*vx) + (0.25*M3**2*R23**2*R32**3*R33)/(vs*vx) + (0.25*M1**2*R12*R13*R22**2*R33**2)/(vs*vx) + (0.25*M2**2*R22**3*R23*R33**2)/(vs*vx) + (1.*M3**2*R22*R23*R32**2*R33**2)/(vs*vx) + (0.25*M3**2*R22**2*R32*R33**3)/(vs*vx)
kap2333 = (0.5*M1**2*R11**2*R21*R31**3)/v**2 + (0.5*M2**2*R21**3*R31**3)/v**2 + (0.5*M3**2*R21*R31**5)/v**2 + (0.5*M1**2*R12**2*R22*R32**3)/vs**2 + (0.5*M2**2*R22**3*R32**3)/vs**2 + (0.5*M3**2*R22*R32**5)/vs**2 + (0.5*M1**2*R11*R12*R22*R31**2*R32)/(v*vs) + (0.5*M2**2*R21*R22**2*R31**2*R32)/(v*vs) + (0.5*M1**2*R11*R12*R21*R31*R32**2)/(v*vs) + (0.5*M2**2*R21**2*R22*R31*R32**2)/(v*vs) + (0.5*M3**2*R22*R31**3*R32**2)/(v*vs) + (0.5*M3**2*R21*R31**2*R32**3)/(v*vs) + (0.5*M1**2*R13**2*R23*R33**3)/vx**2 + (0.5*M2**2*R23**3*R33**3)/vx**2 + (0.5*M3**2*R23*R33**5)/vx**2 + (0.5*M1**2*R11*R13*R23*R31**2*R33)/(v*vx) + (0.5*M2**2*R21*R23**2*R31**2*R33)/(v*vx) + (0.5*M1**2*R11*R13*R21*R31*R33**2)/(v*vx) + (0.5*M2**2*R21**2*R23*R31*R33**2)/(v*vx) + (0.5*M3**2*R23*R31**3*R33**2)/(v*vx) + (0.5*M3**2*R21*R31**2*R33**3)/(v*vx) + (0.5*M1**2*R12*R13*R23*R32**2*R33)/(vs*vx) + (0.5*M2**2*R22*R23**2*R32**2*R33)/(vs*vx) + (0.5*M1**2*R12*R13*R22*R32*R33**2)/(vs*vx) + (0.5*M2**2*R22**2*R23*R32*R33**2)/(vs*vx) + (0.5*M3**2*R23*R32**3*R33**2)/(vs*vx) + (0.5*M3**2*R22*R32**2*R33**3)/(vs*vx)
kap3333 = (0.125*M1**2*R11**2*R31**4)/v**2 + (0.125*M2**2*R21**2*R31**4)/v**2 + (0.125*M3**2*R31**6)/v**2 + (0.125*M1**2*R12**2*R32**4)/vs**2 + (0.125*M2**2*R22**2*R32**4)/vs**2 + (0.125*M3**2*R32**6)/vs**2 + (0.25*M1**2*R11*R12*R31**2*R32**2)/(v*vs) + (0.25*M2**2*R21*R22*R31**2*R32**2)/(v*vs) + (0.25*M3**2*R31**3*R32**3)/(v*vs) + (0.125*M1**2*R13**2*R33**4)/vx**2 + (0.125*M2**2*R23**2*R33**4)/vx**2 + (0.125*M3**2*R33**6)/vx**2 + (0.25*M1**2*R11*R13*R31**2*R33**2)/(v*vx) + (0.25*M2**2*R21*R23*R31**2*R33**2)/(v*vx) + (0.25*M3**2*R31**3*R33**3)/(v*vx) + (0.25*M1**2*R12*R13*R32**2*R33**2)/(vs*vx) + (0.25*M2**2*R22*R23*R32**2*R33**2)/(vs*vx) + (0.25*M3**2*R32**3*R33**3)/(vs*vx)

couplings = {
   '15': str(kap111)+'  # kap111',
   '16': str(kap112)+'  # kap112',
   '17': str(kap122)+'  # kap122',
   '18': str(kap222)+'  # kap222',
   '24': str(kap133)+'  # kap133',
   '25': str(kap113)+'  # kap113',
   '26': str(kap123)+'  # kap123',
   '27': str(kap333)+'  # kap333',
   '28': str(kap233)+'  # kap233',
   '29': str(kap223)+'  # kap223', 
   '19': str(kap1111)+'  # kap1111',
   '20': str(kap1112)+'  # kap1112',
   '21': str(kap1122)+'  # kap1122',
   '22': str(kap1222)+'  # kap1222',
   '23': str(kap2222)+'  # kap2222',
   '30': str(kap1113)+'  # kap1113',
   '31': str(kap1133)+'  # kap1133',
   '32': str(kap1333)+'  # kap1333',
   '33': str(kap3333)+'  # kap3333',
   '34': str(kap2223)+'  # kap2223',
   '35': str(kap2333)+'  # kap2333',
   '36': str(kap2233)+'  # kap2233',
   '37': str(kap1233)+'  # kap1233',
   '38': str(kap1223)+'  # kap1223',
   '39': str(kap1123)+'  # kap1123'
}

# calculate total widths for heavy scalars
# Gammas for each scalar mass in grid, credit to TRSM authors
Gamma_SM = { 130.:0.0049, 140.:0.0081, 150.:0.0168, 160.:0.0787, 170.:0.3600, 180.:0.6020, 190.:0.9900, 200.:1.3700, 210.:1.7700, 220.:2.2200, 230.:2.7300, 240.:3.2900, 250.:3.9200, 260.:4.6300, 270.:5.4100, 280.:6.2700, 290.:7.2100, 300.:8.2300, 310.:9.3500, 320.:10.600, 330.:11.900, 340.:13.300, 350.:15.000, 360.:17.300, 370.:19.800, 380.:22.400, 390.:25.200, 400.:28.200, 410.:31.200, 420.:34.400, 430.:37.700, 440.:41.100, 450.:44.600, 455:46.377, 460.:48.200, 470.:52.000, 480.:55.800, 490.:59.800, 500.:64.000, 510.:68.315, 520.:72.734, 530.:77.265, 540.:81.918, 550.:86.700, 560.:91.622, 570.:96.6974, 580.:101.942, 590.:107.371, 600.:113.000, 650.:144.0,700.:179.0, 800.:264.0, 900.:373.0, 1000.:508.0, 1050.:508.0, 1100.:508.0, 1200.:508.0, 1300.:508.0, 1400.:508.0, 1500.:508.0, 575.:99.298, 525.:74.985, 485.:57.769, 475.:53.892, 425.:36.041, 375.:21.082, 325.:11.244, 275.:5.830, 225.:2.468, 285.: 6.730, }
# calculate the width h3 -> h2 h1, given the mass, the coupling l123 (in GeV) and the sin(mixing angle)
def Gam_h3_to_h2h1(m1, m2, m3, l123):
  if m3 < m1+m2:
    return 0.
  P = (1./2./m3) * math.sqrt( (m3**2 - (m1+m2)**2) * (m3**2 - (m1-m2)**2) )
  width_h3h2h1 = l123**2 * P / 8 / math.pi / m3**2
  return width_h3h2h1
# calculate the width h2 -> h1 h1, given the mass, the coupling l112 (in GeV) and the sin(mixing angle)
def Gam_h2_to_h1h1(m1, m2, l112):
  if m2 < 2*m1:
    return 0.
  width_h2h1h1 = l112**2 * math.sqrt( 1 - 4 * m1**2 / m2**2 ) / 8 / math.pi / m2
  return width_h2h1h1

H2_width = Gamma_SM[M2] * R21**2  + Gam_h2_to_h1h1(M1, M2, kap112)
H3_width = Gamma_SM[M3] * R31**2  + Gam_h2_to_h1h1(M1, M3, kap113) + Gam_h3_to_h2h1(M1, M2, M3, kap123) + Gam_h2_to_h1h1(M2, M3, kap223)

widths = {
  '25':str(0.0038110045676034245), 
  '99925':str(H2_width),
  '99926':str(H3_width)
}

param_card_old = None
mgproc = None

run_card_extras = {}
runName = 'MGPy8.TRSM_{0}_{1}_{2}'.format(topology,decay,M3_str,M2_str)

xqcut = 0

mgproc="""
  generate g g > H H H  [QCD]
 
"""

output = """
output -f
"""

process_str = """
import model loop_sm_twoscalar
define bee = b b~
"""+mgproc+output

m_description = 'MadGraph+Pythia8+A14NNPDF30NLO production pp~>hhh~>{0} in TRSM model, m_iota0 = {1} GeV, m_eta0 = {2} GeV'.format(decay, M3_str, M2_str)

evgenConfig.description = m_description
evgenConfig.keywords += ['BSMHiggs']
run_card_extras['fixed_ren_scale'] =  'True' # 
run_card_extras['fixed_fac_scale'] =  'True' #
run_card_extras['scale'] = 125.5 #
run_card_extras['dsqrt_q2fact1'] = 125.5 #
run_card_extras['dsqrt_q2fact2'] = 125.5
run_card_extras['nevents'] = nevents
run_card_extras['cut_decays'] = 'False'

process_dir = new_process(process_str)

modify_run_card(process_dir=process_dir, runArgs=runArgs, settings=run_card_extras)

param_card_extras = {}
param_card_extras['DECAY'] = widths
param_card_extras['BSM'] = couplings
param_card_extras['MASS'] = masses

modify_param_card(param_card_input='MadGraph_param_card_TRSM_'+topology+'.dat',process_dir=process_dir, params=param_card_extras)

generate(process_dir=process_dir, grid_pack=gridpack_mode, runArgs=runArgs)

arrange_output(process_dir=process_dir, runArgs=runArgs, lhe_version=3)

evgenConfig.contact = ['holly.ann.pacey@cern.ch']

include("Pythia8_i/Pythia8_A14_NNPDF23LO_EvtGen_Common.py")
include("Pythia8_i/Pythia8_MadGraph.py")
if not generate_gridpack:
   genSeq.Pythia8.Commands += [ '25:onMode = on'] #to turn on all decays
if not generate_gridpack:
  # add filter to select events with at least two out of three Higgs decaying to bbbar
  from GeneratorFilters.GeneratorFiltersConf import DecaysFinalStateFilter
  filtSeq += DecaysFinalStateFilter("HiggsToBBBBXFilter")
  filtSeq.HiggsToBBBBXFilter.PDGAllowedParents = [25]
  filtSeq.HiggsToBBBBXFilter.MinNbQuarks = 4

  include("GeneratorFilters/FindJets.py")
  CreateJets(prefiltSeq, 0.4) 
  if not hasattr( filtSeq, "MultiBjetFilter" ): 
      from GeneratorFilters.GeneratorFiltersConf import MultiBjetFilter 
      filtSeq += MultiBjetFilter() 
      pass 
  MultiBjetFilter = filtSeq.MultiBjetFilter
  MultiBjetFilter.NJetsMin = 4 
  MultiBjetFilter.NBJetsMin = 4
  MultiBjetFilter.JetPtMin = 25*GeV 
